# generated by datamodel-codegen:
#   filename:  lcax.schema.json

from __future__ import annotations

from datetime import datetime
from enum import Enum
from typing import Any, Dict, List, Optional, Union

from pydantic import BaseModel, Extra, Field


class Classification(BaseModel):
    class Config:
        allow_population_by_field_name = True

    code: str
    name: str
    system: str


class DistanceUnit(Enum):
    m = 'm'
    km = 'km'


class ExternalEPD(BaseModel):
    class Config:
        allow_population_by_field_name = True

    format: str
    url: str
    version: Optional[str] = None


class ImpactCategory(BaseModel):
    class Config:
        allow_population_by_field_name = True

    a1a3: Optional[float] = None
    a4: Optional[float] = None
    a5: Optional[float] = None
    b1: Optional[float] = None
    b2: Optional[float] = None
    b3: Optional[float] = None
    b4: Optional[float] = None
    b5: Optional[float] = None
    b6: Optional[float] = None
    b7: Optional[float] = None
    c1: Optional[float] = None
    c2: Optional[float] = None
    c3: Optional[float] = None
    c4: Optional[float] = None
    d: Optional[float] = None


class ImpactCategoryKey(Enum):
    gwp = 'gwp'
    odp = 'odp'
    ap = 'ap'
    ep = 'ep'
    pocp = 'pocp'
    adpe = 'adpe'
    adpf = 'adpf'
    penre = 'penre'
    pere = 'pere'
    perm = 'perm'
    pert = 'pert'
    penrt = 'penrt'
    penrm = 'penrm'
    sm = 'sm'
    rsf = 'rsf'
    nrsf = 'nrsf'
    fw = 'fw'
    hwd = 'hwd'
    nhwd = 'nhwd'
    rwd = 'rwd'
    cru = 'cru'
    mrf = 'mrf'
    mer = 'mer'
    eee = 'eee'
    eet = 'eet'


class InternalEPD(BaseModel):
    class Config:
        allow_population_by_field_name = True

    path: str


class LifeCycleStage(Enum):
    a1a3 = 'a1a3'
    a4 = 'a4'
    a5 = 'a5'
    b1 = 'b1'
    b2 = 'b2'
    b3 = 'b3'
    b4 = 'b4'
    b5 = 'b5'
    b6 = 'b6'
    b7 = 'b7'
    c1 = 'c1'
    c2 = 'c2'
    c3 = 'c3'
    c4 = 'c4'
    d = 'd'


class Source(BaseModel):
    class Config:
        allow_population_by_field_name = True

    name: str
    url: Optional[str] = None


class Standard(Enum):
    en15804_a1 = 'EN15804A1'
    en15804_a2 = 'EN15804A2'
    unknown = 'UNKNOWN'


class SubType(Enum):
    generic = 'Generic'
    specific = 'Specific'
    industry = 'Industry'
    representative = 'Representative'


class TransportType(Enum):
    truck = 'truck'
    train = 'train'
    ship = 'ship'
    plane = 'plane'


class Unit(Enum):
    m = 'M'
    m2 = 'M2'
    m3 = 'M3'
    kg = 'KG'
    tones = 'TONES'
    pcs = 'PCS'
    l = 'L'
    m2_r1 = 'M2R1'
    unknown = 'UNKNOWN'


class Conversion(BaseModel):
    class Config:
        allow_population_by_field_name = True

    to: Unit
    value: float


class EPD(BaseModel):
    class Config:
        allow_population_by_field_name = True

    adpe: Optional[ImpactCategory] = None
    adpf: Optional[ImpactCategory] = None
    ap: Optional[ImpactCategory] = None
    comment: Optional[str] = None
    conversions: Optional[List[Conversion]] = None
    cru: Optional[ImpactCategory] = None
    declared_unit: Unit
    eee: Optional[ImpactCategory] = None
    eet: Optional[ImpactCategory] = None
    ep: Optional[ImpactCategory] = None
    format_version: str
    fw: Optional[ImpactCategory] = None
    gwp: Optional[ImpactCategory] = None
    hwd: Optional[ImpactCategory] = None
    id: str
    location: str
    mer: Optional[ImpactCategory] = None
    meta_data: Optional[Dict[str, Any]] = None
    mrf: Optional[ImpactCategory] = None
    name: str
    nhwd: Optional[ImpactCategory] = None
    nrsf: Optional[ImpactCategory] = None
    odp: Optional[ImpactCategory] = None
    penre: Optional[ImpactCategory] = None
    penrm: Optional[ImpactCategory] = None
    penrt: Optional[ImpactCategory] = None
    pere: Optional[ImpactCategory] = None
    perm: Optional[ImpactCategory] = None
    pert: Optional[ImpactCategory] = None
    pocp: Optional[ImpactCategory] = None
    published_date: datetime
    reference_service_life: Optional[int] = Field(None, ge=0)
    rsf: Optional[ImpactCategory] = None
    rwd: Optional[ImpactCategory] = None
    sm: Optional[ImpactCategory] = None
    source: Optional[Source] = None
    standard: Standard
    subtype: SubType
    valid_until: datetime
    version: str


class EPDSourceItem(BaseModel):
    class Config:
        extra = Extra.forbid
        allow_population_by_field_name = True

    epd: EPD


class EPDSourceItem1(BaseModel):
    class Config:
        extra = Extra.forbid
        allow_population_by_field_name = True

    externalepd: ExternalEPD


class EPDSourceItem2(BaseModel):
    class Config:
        extra = Extra.forbid
        allow_population_by_field_name = True

    internalepd: InternalEPD


class Transport(BaseModel):
    class Config:
        allow_population_by_field_name = True

    distance: float
    distance_unit: DistanceUnit = Field(..., alias='distanceUnit')
    id: str
    name: str
    transport_type: TransportType = Field(..., alias='transportType')


class EPDPart(BaseModel):
    class Config:
        allow_population_by_field_name = True

    epd_source: Union[EPDSourceItem, EPDSourceItem1, EPDSourceItem2] = Field(
        ..., alias='epdSource'
    )
    id: str
    meta_data: Optional[Dict[str, Any]] = Field(None, alias='metaData')
    name: str
    part_quantity: float = Field(..., alias='partQuantity')
    part_unit: Unit = Field(..., alias='partUnit')
    reference_service_life: float = Field(..., alias='referenceServiceLife')
    transport: Optional[Transport] = None


class Assembly(BaseModel):
    class Config:
        allow_population_by_field_name = True

    category: Optional[str] = None
    classification: Optional[List[Classification]] = None
    comment: Optional[str] = None
    description: str
    id: str
    meta_data: Optional[Dict[str, Any]] = Field(None, alias='metaData')
    name: str
    parts: Dict[str, EPDPart]
    quantity: float
    results: Optional[Dict[str, Any]] = None
    unit: Unit


class LCAxProject(BaseModel):
    class Config:
        allow_population_by_field_name = True

    classification_system: Optional[str] = Field(None, alias='classificationSystem')
    comment: Optional[str] = None
    description: str
    emission_parts: Dict[str, Assembly] = Field(..., alias='emissionParts')
    format_version: str = Field(..., alias='formatVersion')
    id: str
    impact_categories: List[ImpactCategoryKey] = Field(..., alias='impactCategories')
    lcia_method: Optional[str] = Field(None, alias='lciaMethod')
    life_cycle_stages: List[LifeCycleStage] = Field(..., alias='lifeCycleStages')
    life_span: Optional[int] = Field(None, alias='lifeSpan', ge=0)
    location: str
    meta_data: Optional[Dict[str, Any]] = Field(None, alias='metaData')
    name: str
    results: Optional[Dict[str, Any]] = None
